# Getestet mit Python 3.11.6 und PySide 6.5.3

import sys
import PySide6.QtWidgets as widgets
import PySide6.QtCore as core
import PySide6.QtGui as gui
import PySide6.QtUiTools as uic

# Viele rote Kringel, weil die Typen erst bekannt sind, wenn der QUiLoader gelaufen ist.
# Man könnte mit typing.cast abhelfen, aber das wird unübersichtlich.

app = widgets.QApplication(sys.argv)
w = uic.QUiLoader().load("mainwindow.ui")
d = uic.QUiLoader().load("eisbestellung.ui")
d2 = uic.QUiLoader().load("zeichnen.ui")

def clickBestelleEis():
    #d.lineEditErbeere.setText("abcde")
    if d.exec() == widgets.QDialog.DialogCode.Accepted:
        print(d.lineEditErbeere.text() + " " + str(d.radioButtonBecher.isChecked()))
    
def dateiÖffnen():
    filename = widgets.QFileDialog.getOpenFileName(filter = "Textdateien (*.txt)")[0]
    if filename != "":
        print(filename)
    else:
        print("Abgebrochen")

def zeichnungÖffnen():
    d2.show()

def sliderValueChange():
    d2.widget.repaint()

class EventFilter(core.QObject):
    def eventFilter(self, obj, event):
        if event.type() == core.QEvent.Paint:
            painter = gui.QPainter(obj)
            painter.drawLine(0, 0, 100, d2.horizontalSlider.sliderPosition())
            painter.end()
            return True
        return core.QObject.eventFilter(self, obj, event)
    
eventFilter = EventFilter()

w.pushButtonBestelleEis.clicked.connect(clickBestelleEis)
w.actionEis_bestellen.triggered.connect(clickBestelleEis)
w.actionOeffnen.triggered.connect(dateiÖffnen)
w.actionNeu.triggered.connect(zeichnungÖffnen)
d2.widget.installEventFilter(eventFilter)
d2.horizontalSlider.valueChanged.connect(sliderValueChange)

w.show()
sys.exit(app.exec())